unit MyExpiry;

interface

	function ExpiredVersion: boolean;

implementation

	uses
		MyVersionResource, MyEmergencyNotifier, MyUtils;

	procedure GetCompiledDate (var date: longInt);
		var
			d: DateTimeRec;
			s: str31;
			p: integer;
	begin
		s := compdate;
		p := Pos('/', s);
		d.day := StrToNum(copy(s, 1, p - 1));
		Delete(s, 1, p);
		p := Pos('/', s);
		d.month := StrToNum(copy(s, 1, p - 1));
		Delete(s, 1, p);
		d.year := 1900 + StrToNum(s);
		d.hour := 0;
		d.minute := 0;
		d.second := 0;
		Date2Secs(d, date);
	end;

	function ExpiredVersion: boolean;
		var
			date, cdate, diff: longInt;
			vers: versionRecord;
	begin
		ExpiredVersion := false;
		GetVersion(vers);
		if vers.devcode <> $80 then begin
			GetDateTime(date);
			GetCompiledDate(cdate);
			diff := (date - cdate) div 2678400;
			if diff >= 6 then begin
				EmergencyNotify('This developmental version has expired.  Set your clock back, or get a new version');
				ExpiredVersion := true;
			end
			else if diff >= 4 then begin
				EmergencyNotify('This developmental version has expired.  It will work for a while, and then stop working forever.  Get a new version');
			end;
		end;
	end;


end.
