unit MyMenus;

interface

	procedure SetIDItem (menu, item: integer; s: str255);
	function GetIDItem (menu, item: integer): str255;
	procedure SetItemEnable (mh: menuHandle; item: integer; enable: boolean);
	function GetItemEnable (mh: menuHandle; item: integer): boolean;
	procedure SetIDItemEnable (menu, item: integer; enable: boolean);
	function GetIDItemEnable (menu, item: integer): boolean;
	procedure DotItem (mh: menuHandle; item: integer; dotted: boolean);
	procedure ClearMenuHandle (mh: MenuHandle);

implementation

{$S Util}
	procedure ClearMenuHandle (mh: MenuHandle);
	begin
		while (CountMItems(mh) > 0) do begin
			DelMenuItem(mh, 1);
		end;
	end;

{$S Util}
	procedure SetIDItem (menu, item: integer; s: str255);
	begin
		SetItem(GetMHandle(menu), item, s);
	end;

{$S Util}
	function GetIDItem (menu, item: integer): str255;
		var
			s: str255;
	begin
		GetItem(GetMHandle(menu), item, s);
		GetIDItem := s;
	end;

{$S Util}
	procedure SetItemEnable (mh: menuHandle; item: integer; enable: boolean);
	begin
		if enable then begin
			EnableItem(mh, item);
		end
		else begin
			DisableItem(mh, item);
		end;
	end;

{$S Util}
	procedure SetIDItemEnable (menu, item: integer; enable: boolean);
	begin
		SetItemEnable(GetMHandle(menu), item, enable);
	end;

{$S Util}
	function GetItemEnable (mh: menuHandle; item: integer): boolean;
	begin
		if item > 31 then begin
			GetItemEnable := true;
		end
		else begin
			GetItemEnable := BTST(mh^^.enableFlags, item);
		end;
	end;

{$S Util}
	function GetIDItemEnable (menu, item: integer): boolean;
	begin
		GetIDItemEnable := GetItemEnable(GetMHandle(menu), item);
	end;

{$S Util}
	procedure DotItem (mh: menuHandle; item: integer; dotted: boolean);
	begin
		if dotted then
			SetItemMark(mh, item, '')
		else
			SetItemMark(mh, item, chr(0));
	end;

end.