unit MyTypes;

{ From Peter's PNL Libraries }
{ Copyright 1992 Peter N Lewis }
{ This source may be used for any non-commercial purposes as long as I get a mention }
{ in the About box and Docs of any derivative program.  It may not be used in any commercial }
{ application without my permission }

interface

{$IFC undefined THINK_Pascal}
	uses
		Events;
{$ENDC}

	const
		sysWDProcID = $4552494B;		{ 'ERIK' }
		myErr = -5;
		myErr2 = -6;
		cancelErr = myErr2;
		myErr3 = -7;
		noType = 0;							{ should be OSType(0) !!! }
		fsNoCache = $20;
		fsNewLine = $80; { put the newline character in the high byte of ioPosMode }
		bad_rn = -32768;

	const
		M_Apple = 128;
		M_File = 129;
		M_Edit = 130;
		M_Windows = 150;

	const
		CAbout = 'abou';
		CNew = 'new ';
		COpen = 'open';
		CSave = 'save';
		CSaveAs = 'svas';
		CClose = 'clos';
		CPreferences = 'pref';
		CPageSetUp = 'pgsu';
		CPrint = 'prnt';
		CHelp = 'help';
		CQuit = 'quit';
		CUndo = 'undo';
		CCut = 'cut ';
		CCopy = 'copy';
		CPaste = 'past';
		CClear = 'clea';
		CSelectAll = 'sela';

	const									{ Low Memory Globals }
		curApNameA = $910;
		ticksA = $16A;
		SFSaveDiskA = $214;
		CurDirStoreA = $398;
		bad_refnum = -32768;

	const									{ Other OS constants, probably declared somewhere now }
		kSysEnvironsVersion = 1;
		kOSEvent = app4Evt;				{event used by MultiFinder}
		kSuspendResumeMessage = 1;	{high byte of suspend/resume event message}
		kResumeMask = 1;					{bit of message field for resume vs. suspend}
		kMouseMovedMessage = $FA;	{high byte of mouse-moved event message}
		kNoEvents = 0;						{no events mask}

	const									{ Constants that aren't normally defined }
		drawCntlMsg = 0;
		testCntlMsg = 1;
		calcCRgnsMsg = 2;
		initCntlMsg = 3;
		dispCntlMsg = 4;
		posCntlMsg = 5;
		thumbCntlMsg = 6;
		dragCntlMsg = 7;
		autoTrackMsg = 8;

	const
		EMUndo = 1;
		EMCut = 3;
		EMCopy = 4;
		EMPaste = 5;
		EMClear = 6;
		EMSelectAll = 7;

	const
		nulChar = 0;
		homeChar = $01;
		enterChar = $03;
		endChar = $04;
		helpChar = $05;
		backSpaceChar = $08;
		tabChar = $09;
		lfChar = $0A;
		pageUpChar = $0b;
		pageDownChar = $0c;
		crChar = $0D;
		escChar = $1b;
		escKey = $35;
		clearChar = $1b;
		clearKey = $47;
		leftArrowChar = $1c;
		rightArrowChar = $1d;
		upArrowChar = $1e;
		downArrowChar = $1f;
		spaceChar = $20;
		delChar = $7f;
		bulletChar = $a5;
		undoKey = $7a;
		cutKey = $78;
		copyKey = $63;
		pasteKey = $76;

	const
		nul = chr(nulChar);
		enter = chr(enterChar);
		bs = chr(backSpaceChar);
		tab = chr(tabChar);
		lf = chr(lfChar);
		cr = chr(crChar);
		leftArrow = chr(leftArrowChar);
		rightArrow = chr(rightArrowChar);
		upArrow = chr(upArrowChar);
		downArrow = chr(downArrowChar);
		esc = chr(escChar);
		spc = chr(spaceChar);
		del = chr(delChar);

	type
		integerP = ^integer;
		integerH = ^integerP;
		longIntP = ^longInt;
		longIntH = ^longIntP;
		forkType = (no_fork, data_fork, rsrc_fork, both_fork);
		buf255 = packed array[0..255] of char;
		CRLFTypes = (CL_CRLF, CL_CR, CL_LF);
		charSet = set of char;
		short = integer;
		long = longInt;

implementation

end.